commit b3a45adc90bbbdf7a62e9ff301b32f43ba93cdad
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Thu Apr 23 21:57:50 2020 +0200

    Shortcut identity VEC_PERM expansion [PR94710]
    
    This PR is about the rs6000 backend emitting wrong assembly
    for whole vector shift by 0, and while I think it is desirable
    to fix the backend, I don't see a point why the expander should
    try to emit that, whole vector shift by 0 is identity, we can just
    return the operand.
    
    2020-04-23  Jakub Jelinek  <jakub@redhat.com>
    
            PR target/94710
            * optabs.c (expand_vec_perm_const): For shift_amt const0_rtx
            just return v2.
    
    (cherry picked from commit f51be2fb8653f81092f8158a0f0527275f86603b)

diff --git a/gcc/optabs.c b/gcc/optabs.c
index a74d7be0d09..51d838d4f93 100644
--- a/gcc/optabs.c
+++ b/gcc/optabs.c
@@ -5518,6 +5518,8 @@ expand_vec_perm_const (machine_mode mode, rtx v0, rtx v1,
       if (shift_amt)
 	{
 	  struct expand_operand ops[3];
+	  if (shift_amt == const0_rtx)
+	    return v0;
 	  if (shift_code != CODE_FOR_nothing)
 	    {
 	      create_output_operand (&ops[0], target, mode);

